searchNodes=[{"doc":"The link to WeChat Official Account Platform API document in Chinese | English.Currently, there are two ways to use the WeChat's APIs:As common application, directly integrates WeChat's APIs after turn on your WeChat Official Account into the developer mode (see details);As component application, authorizes your WeChat Official Account to the WeChat Official Account third-party platform application, leverages a set of common solutions from the third-party platform (see details).Refer the official document's recommend to manage access token (see details), we need to temporarily storage access token in a centralization way, we prepare four behaviours to manage the minimum responsibilities for each use case.Use this library in the 3rd-party web app which can read the temporary storage data (e.g. access token/jsapi-ticket/card-ticket) from the centralization nodes(hereinafter &quot;hub&quot;):The WeChat.Storage.Client storage adapter behaviour is required for the common application;The WeChat.Storage.ComponentClient storage adapter behaviour is required for the component application.Use this library in the hub web app:The WeChat.Storage.Hub storage adapter behaviour is required for the common application;The WeChat.Storage.ComponentHub storage adapter behaviour is required for the component application.As usual, the hub web app is one-off setup to use this library, most of time we use elixir_wechat is in the 3rd-party web app as a client, so here provide a default storage adapter to conveniently initialize it as a client use case:The WeChat.Storage.Adapter.DefaultClient implements WeChat.Storage.Client behaviour, and is used for the common application by default:defmodule MyClient do use WeChat, adapter_storage: {:default, &quot;http://localhost:4000&quot;} end # # the above equals the following # defmodule MyClient do use WeChat, adapter_storage: {WeChat.Storage.Adapter.DefaultClient, &quot;http://localhost:4000&quot;} endThe WeChat.Storage.Adapter.DefaultComponentClient implements WeChat.Storage.ComponentClient behaviour, and is used for the component application by default:defmodule MyComponentClient do use WeChat.Component, adapter_storage: {:default, &quot;http://localhost:4000&quot;} end # # the above equals the following # defmodule MyComponentClient do use WeChat.Component, adapter_storage: {WeChat.Storage.Adapter.DefaultComponentClient, &quot;http://localhost:4000&quot;} endUsageAs common applicationdefmodule MyClient do use WeChat, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, appid: &quot;MyAppID&quot; end MyClient.request(:post, url: &quot;WeChatURL1&quot;, body: %{}, query: []) MyClient.request(:get, url: &quot;WeChatURL2&quot;, query: [])Or use WeChat.request/2 directlyWeChat.request(:post, url: &quot;WeChatURL1&quot;, appid: &quot;MyAppID&quot;, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, body: %{}, query: []) WeChat.request(:get, url: &quot;WeChatURL2&quot;, appid: &quot;MyAppID&quot;, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, query: [])As component applicationdefmodule MyComponentClient do use WeChat.Component, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, appid: &quot;MyAppID&quot;, authorizer_appid: &quot;MyAuthorizerAppID&quot; end MyComponentClient.request(:post, url: &quot;WeChatURL1&quot;, body: %{}, query: []) MyComponentClient.request(:post, url: &quot;WeChatURL2&quot;, query: [])Or use WeChat.request/2 directlyWeChat.request(:post, url: &quot;WeChatURL1&quot;, appid: &quot;MyAppID&quot;, authorizer_appid: &quot;MyAuthorizerAppID&quot;, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, body: %{}, query: []) WeChat.request(:get, url: &quot;WeChatURL2&quot;, appid: &quot;MyAppID&quot;, authorizer_appid: &quot;MyAuthorizerAppID&quot;, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, query: [])","ref":"WeChat.html","title":"WeChat","type":"module"},{"doc":"The expire time (in seconds) to access_token and ticket temporary storage, by default it is 7200 seconds.For hub scenario, both common and component application can override this function in the defined basic module if needed, and then can use this function as a global setting to use in access_token and ticket life cycle management, for example:defmodule MyHubComponentClient do use WeChat.Component, scenario: :hub, adapter_storage: MyComponentLocalStorage def expires_in(), do: 7000 enddefmodule MyHubCommonClient do use WeChat, scenario: :hub, adapter_storage: MyCommonLocalStorage def expires_in(), do: 7000 endFor client scenario, no need to use this function, the local registry for access_token and ticket will use hub's response(contain time related) when fetch/refresh access_token and ticket to manage them as a client side temporary cache.","ref":"WeChat.html#expires_in/0","title":"WeChat.expires_in/0","type":"function"},{"doc":"A function helper to fetch common application's access token.When apply it to hub, if no available access token from hub's storage, there will use the set account's secret_key to refresh a new one.","ref":"WeChat.html#fetch_access_token/2","title":"WeChat.fetch_access_token/2","type":"function"},{"doc":"Call WeChat's HTTP API functions in a explicit way.We can defined a global module to assemble appid, authorizer_appid(only used for &quot;component&quot; application), and adapter_storage.For example:defmodule MyClient do use WeChat, appid: &quot;...&quot;, adapter_storage: &quot;...&quot; enddefmodule MyComponentClient do use WeChat.Component, appid: &quot;...&quot;, authorizer_appid: &quot;...&quot;, adapter_storage: &quot;...&quot; endAnd then we can use MyClient or MyComponentClient to call request/2, as usual, there dose NOT need to pass the above parameters when invoke, but if needed you input them to override.We can directly use WeChat.request/2 as well, in this way, the appid, authorizer_appid(only used for &quot;component&quot; application), and adapter_storage are required for each invoke.The method parameter can be used as one of method/0.Options:appid, required, if you use a global module to assemble it, this value is optional. If you are using a common application, appid means the application id of your WeChat Official Account; if you are a component application, appid means the application id of your WeChat Official Account third-party platform application.:authorizer_appid, optional, if you are using a component application, this value is required, the application id of your WeChat Official Account third-party platform application.:adapter_storage, required, the predefined storage way to used for access_token, jsapi_ticket, and card_ticket, here provide a {:default, &quot;MyHubURL&quot;} as option.:url, required, the URL to call WeChat's HTTP API function, for example, &quot;/cgi-bin/material/get_materialcount&quot;, also you can input a completed URL like this &quot;https://api.weixin.qq.com/cgi-bin/material/get_materialcount&quot;.:host, optional, the host of URI to call WeChat's HTTP API function, if you input a completed URL with host, this value is optional, by default it is &quot;api.weixin.qq.com&quot;.:scheme, optional, the scheme of URI to call WeChat's HTTP API function, if you input a completed URL with scheme, this value is optional, by default it is &quot;https&quot;.:port, optional, the port of URI to call WeChat's HTTP API function, if you input a completed URL with port, this value is optional, by default it is &quot;443&quot;(as integer).:body, optional, a map, decided by your used WeChat's HTTP API functions, following WeChat official document to setup the body of the request.:query, optional, a keyword, decided by your used WeChat's HTTP API functions, following WeChat official document to setup the query string of the request, this library will automatically appended a proper access_token into the query of each request, so we do NOT need to input access_token parameter.:opts, optional, custom, per-request middleware or adapter options (exported from Tesla)","ref":"WeChat.html#request/2","title":"WeChat.request/2","type":"function"},{"doc":"To initialize WeChat Card functions in JSSDK, use wxcard_ticket and card_id to generate a signature for this scenario, see official document.","ref":"WeChat.html#sign_card/1","title":"WeChat.sign_card/1","type":"function"},{"doc":"See WeChat.sign_card/1.","ref":"WeChat.html#sign_card/2","title":"WeChat.sign_card/2","type":"function"},{"doc":"See WeChat.sign_card/1.","ref":"WeChat.html#sign_card/3","title":"WeChat.sign_card/3","type":"function"},{"doc":"To configure and load WeChat JSSDK in the target page's url properly, use jsapi_ticket and url to generate a signature for this scenario.","ref":"WeChat.html#sign_jssdk/2","title":"WeChat.sign_jssdk/2","type":"function"},{"doc":"","ref":"WeChat.html#t:error/0","title":"WeChat.error/0","type":"type"},{"doc":"","ref":"WeChat.html#t:method/0","title":"WeChat.method/0","type":"type"},{"doc":"Use for WeChat official accounts third-party platform applications, WeChat module is usually used for WeChat's functional APIs invoke directly, WeChat.Component is used to call to refetch/refresh authorizer's access token internally.","ref":"WeChat.Component.html","title":"WeChat.Component","type":"module"},{"doc":"A function helper to fetch authorizer application's access token from component application.When apply it to hub, if no available access token from hub's storage, there will use refresh_token to refetch a new one, this function can be used for refresh function.","ref":"WeChat.Component.html#fetch_access_token/3","title":"WeChat.Component.fetch_access_token/3","type":"function"},{"doc":"A function helper to fetch component application's access token.When apply it to hub, if no available component access token from hub's storage, there will use verify_ticket to refetch a new one, this function can be used for refresh function.","ref":"WeChat.Component.html#fetch_component_access_token/2","title":"WeChat.Component.fetch_component_access_token/2","type":"function"},{"doc":"The storage adapter specification for WeChat common application.Since we need to temporarily storage some key data(e.g. access_token) for invoking WeChat APIs, this module is used for customizing the persistence when use elixir_wechat in a client side of WeChat common application.Notice: the scenario as a client, we only need to implement the minimum functions to automatically append the required parameters from the persistence.Writing custom storage adapterExample for WeChat Official Account Platform applicationdefmodule MyAppStorageClient do @behaviour WeChat.Storage.Client @impl true def fetch_access_token(appid, args) do access_token = &quot;Get access_token by appid from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def fetch_ticket(appid, type, args) do ticket = &quot;Get jsapi-ticket/card-ticket from your persistence...&quot; {:ok, ticket} end @impl true def refresh_access_token(appid, access_token, args) do access_token = &quot;Refresh access_token by appid from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end endUse MyAppStorageClientGlobal configure MyAppStorageClientdefmodule Client do use WeChat, adapter_storage: {MyAppStorageClient, args} end defmodule Client do use WeChat, adapter_storage: MyAppStorageClient endDynamically set MyAppStorageClient when call WeChat.request/2WeChat.request(:post, url: ..., adapter_storage: {MyAppStorageClient, args}, ...) WeChat.request(:post, url: ..., adapter_storage: MyAppStorageClient, ...)Notice: The above args will be returned back into each implement of callback function, if not input it, args will be as an empty list in callback.","ref":"WeChat.Storage.Client.html","title":"WeChat.Storage.Client","type":"behaviour"},{"doc":"Fetch access_token of WeChat common application.","ref":"WeChat.Storage.Client.html#c:fetch_access_token/2","title":"WeChat.Storage.Client.fetch_access_token/2","type":"callback"},{"doc":"Fetch ticket of WeChat common application, the option of type parameter is &quot;wx_card&quot; or &quot;jsapi&quot;(refer WeChat Official document).","ref":"WeChat.Storage.Client.html#c:fetch_ticket/3","title":"WeChat.Storage.Client.fetch_ticket/3","type":"callback"},{"doc":"Refresh access_token of WeChat common application.","ref":"WeChat.Storage.Client.html#c:refresh_access_token/3","title":"WeChat.Storage.Client.refresh_access_token/3","type":"callback"},{"doc":"The storage adapter specification for WeChat component application.Since we need to temporarily storage some key data(e.g. access_token/component_access_token) for invoking WeChat APIs, this module is used for customizing the persistence when use elixir_wechat in a client side of WeChat component application.Notice: as a client, we only need to implement the minimum functions to automatically append the required parameters from the persistence.Writing custom storage adapterExample for WeChat third-party platform applicationdefmodule MyComponentAppStorageClient do @behaviour WeChat.Storage.ComponentClient @impl true def fetch_access_token(appid, authorizer_appid, args) do access_token = &quot;Get authorizer&#39;s access_token by appid and authorizer appid from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl ture def fetch_component_access_token(appid, args) do access_token = &quot;Get component access_token by component appid from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def refresh_access_token(appid, authorizer_appid, access_token, args) do access_token = &quot;Refresh access_token by appid from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def fetch_ticket(appid, type, args) do ticket = &quot;Get jsapi-ticket/card-ticket from your persistence...&quot; {:ok, ticket} end endUse MyComponentAppStorageClientGlobal configure MyComponentAppStorageClientdefmodule Client do use WeChat, adapter_storage: {MyComponentAppStorageClient, args} end defmodule Client do use WeChat, adapter_storage: MyComponentAppStorageClient endDynamically set MyComponentAppStorageClient when call WeChat.request/2WeChat.request(:post, url: ..., adapter_storage: {MyComponentAppStorageClient, args}, ...) WeChat.request(:post, url: ..., adapter_storage: MyComponentAppStorageClient, ...)Notice: The above args will be returned back into each implement of callback function, if not input it, args will be as an empty list in callback.","ref":"WeChat.Storage.ComponentClient.html","title":"WeChat.Storage.ComponentClient","type":"behaviour"},{"doc":"Fetch authorizer's access_token in WeChat component application.","ref":"WeChat.Storage.ComponentClient.html#c:fetch_access_token/3","title":"WeChat.Storage.ComponentClient.fetch_access_token/3","type":"callback"},{"doc":"Fetch access_token of WeChat component application.","ref":"WeChat.Storage.ComponentClient.html#c:fetch_component_access_token/2","title":"WeChat.Storage.ComponentClient.fetch_component_access_token/2","type":"callback"},{"doc":"Fetch authorizer's ticket of WeChat component application, the option of type parameter is &quot;wx_card&quot; or &quot;jsapi&quot;(refer WeChat Official document).","ref":"WeChat.Storage.ComponentClient.html#c:fetch_ticket/4","title":"WeChat.Storage.ComponentClient.fetch_ticket/4","type":"callback"},{"doc":"Refresh authorizer's access_token in WeChat component application.","ref":"WeChat.Storage.ComponentClient.html#c:refresh_access_token/4","title":"WeChat.Storage.ComponentClient.refresh_access_token/4","type":"callback"},{"doc":"The storage adapter specification for WeChat component application.Since we need to temporarily storage some key data(e.g. access_token/component_access_token) for invoking WeChat APIs, this module is used for customizing the persistence when use elixir_wechat in the centralization nodes(hereinafter &quot;hub&quot;) side of WeChat component application.Notice: the scenario as a hub, we need to implement the completed functions to maintain the persistence.Writing custom storage adapterExample for WeChat 3rd-party Platform applicationdefmodule MyComponentAppStorageHub do @behaviour WeChat.Storage.ComponentHub @impl true def fetch_access_token(appid, authorizer_appid, args) do access_token = &quot;Get authorizer&#39;s access_token for WeChat component application from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def fetch_component_access_token(appid, args) do access_token = &quot;Get component access_token for WeChat component application from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def fetch_component_verify_ticket(appid, args) do component_verify_ticket = &quot;Get component_verify_ticket for WeChat component application from your persistence...&quot; {:ok, component_verify_ticket} end @impl true def fetch_secret_key(appid, args) do secret_key = &quot;Get component application secret_key from your persistence...&quot; secret_key end @impl true def fetch_ticket(appid, authorizer_appid, type, args) do ticket = &quot;Get authorizer account&#39;s ticket for WeChat component application from your persistence...&quot; {:ok, ticket} end @impl true def refresh_access_token(appid, authorizer_appid, access_token, args) do access_token = &quot;Refresh authorizer&#39;s access_token for WeChat component application from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def refresh_component_access_token(appid, component_access_token, args) do access_token = &quot;Refresh access_token of WeChat component application...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def save_access_token(appid, authorizer_appid, access_token, refresh_token, args) do # Save authorizer&#39;s access_token and its refresh_token to your persistence end @impl true def save_component_access_token(appid, component_access_token, args) do # Save access_token of WeChat component application end @impl true def save_component_verify_ticket(appid, component_verify_ticket, args) do # Save component_verify_ticket to your persistence end @impl true def save_ticket(appid, authorizer_appid, ticket, type, args) do # Save authorizer account&#39;s ticket to your persistence end endUse MyComponentAppStorageHubGlobal configure MyComponentAppStorageHubdefmodule Client do use WeChat, adapter_storage: {MyComponentAppStorageHub, args} end defmodule Client do use WeChat, adapter_storage: MyComponentAppStorageHub endDynamically set MyComponentAppStorageHub when call WeChat.request/2WeChat.request(:post, url: ..., adapter_storage: {MyComponentAppStorageHub, args}, ...) WeChat.request(:post, url: ..., adapter_storage: MyComponentAppStorageHub, ...)Notice: The above args will be returned back into each implement of callback function, if not input it, args will be as an empty list in callback.","ref":"WeChat.Storage.ComponentHub.html","title":"WeChat.Storage.ComponentHub","type":"behaviour"},{"doc":"Get authorizer's access_token for WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:fetch_access_token/3","title":"WeChat.Storage.ComponentHub.fetch_access_token/3","type":"callback"},{"doc":"Get access_token of WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:fetch_component_access_token/2","title":"WeChat.Storage.ComponentHub.fetch_component_access_token/2","type":"callback"},{"doc":"Fetch component_verify_ticket of WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:fetch_component_verify_ticket/2","title":"WeChat.Storage.ComponentHub.fetch_component_verify_ticket/2","type":"callback"},{"doc":"Get secret_key of WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:fetch_secret_key/2","title":"WeChat.Storage.ComponentHub.fetch_secret_key/2","type":"callback"},{"doc":"Fetch authorizer account's ticket in WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:fetch_ticket/4","title":"WeChat.Storage.ComponentHub.fetch_ticket/4","type":"callback"},{"doc":"Refresh authorizer's access_token for WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:refresh_access_token/4","title":"WeChat.Storage.ComponentHub.refresh_access_token/4","type":"callback"},{"doc":"Refresh access_token of WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:refresh_component_access_token/3","title":"WeChat.Storage.ComponentHub.refresh_component_access_token/3","type":"callback"},{"doc":"Save authorizer's access_token for WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:save_access_token/5","title":"WeChat.Storage.ComponentHub.save_access_token/5","type":"callback"},{"doc":"Save access_token of WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:save_component_access_token/3","title":"WeChat.Storage.ComponentHub.save_component_access_token/3","type":"callback"},{"doc":"Save component_verify_ticket of WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:save_component_verify_ticket/3","title":"WeChat.Storage.ComponentHub.save_component_verify_ticket/3","type":"callback"},{"doc":"Save authorizer account's ticket in WeChat component application.","ref":"WeChat.Storage.ComponentHub.html#c:save_ticket/5","title":"WeChat.Storage.ComponentHub.save_ticket/5","type":"callback"},{"doc":"The storage adapter specification for WeChat common application.Since we need to temporarily storage some key data(e.g. access_token) for invoking WeChat APIs, this module is used for customizing the persistence when use elixir_wechat in the centralization nodes(hereinafter &quot;hub&quot;) side of WeChat common application.Notice: the scenario as a hub, we need to implement the completed functions to maintain the persistence.Writing custom storage adapterExample for WeChat Official Account Platform applicationdefmodule MyAppStorageHub do @behaviour WeChat.Storage.Hub @impl true def fetch_secret_key(appid, args) do secret_key = &quot;Get secret_key by appid from your persistence...&quot; secret_key end @impl true def fetch_access_token(appid, args) do access_token = &quot;Get access_token by appid from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def fetch_ticket(appid, type, args) do ticket = &quot;Get ticket by appid from your persistence...&quot; {:ok, ticket} end @impl true def refresh_access_token(appid, access_token, args) do access_token = &quot;Refresh access_token by appid from your persistence...&quot; {:ok, %WeChat.Token{access_token: access_token}} end @impl true def save_access_token(appid, access_token, args) do # Save access_token by appid to your persistence end @impl true def save_ticket(appid, ticket, type, args) do # Save ticket by appid to your persistence end endUse MyAppStorageHubGlobal configure MyAppStorageHubdefmodule Client do use WeChat, adapter_storage: {MyAppStorageHub, args} end defmodule Client do use WeChat, adapter_storage: MyAppStorageHub endDynamically set MyAppStorageHub when call WeChat.request/2WeChat.request(:post, url: ..., adapter_storage: {MyAppStorageHub, args}, ...) WeChat.request(:post, url: ..., adapter_storage: MyAppStorageHub, ...)Notice: The above args will be returned back into each implement of callback function, if not input it, args will be as an empty list in callback.","ref":"WeChat.Storage.Hub.html","title":"WeChat.Storage.Hub","type":"behaviour"},{"doc":"Fetch access_token of WeChat common application.","ref":"WeChat.Storage.Hub.html#c:fetch_access_token/2","title":"WeChat.Storage.Hub.fetch_access_token/2","type":"callback"},{"doc":"Fetch secret_key of WeChat common application.","ref":"WeChat.Storage.Hub.html#c:fetch_secret_key/2","title":"WeChat.Storage.Hub.fetch_secret_key/2","type":"callback"},{"doc":"Fetch ticket of WeChat common application, the option of type parameter is &quot;wx_card&quot; or &quot;jsapi&quot;(refer WeChat Official document).","ref":"WeChat.Storage.Hub.html#c:fetch_ticket/3","title":"WeChat.Storage.Hub.fetch_ticket/3","type":"callback"},{"doc":"Refresh access_token of WeChat common application.","ref":"WeChat.Storage.Hub.html#c:refresh_access_token/3","title":"WeChat.Storage.Hub.refresh_access_token/3","type":"callback"},{"doc":"Save access_token of WeChat common application.","ref":"WeChat.Storage.Hub.html#c:save_access_token/3","title":"WeChat.Storage.Hub.save_access_token/3","type":"callback"},{"doc":"Save ticket of WeChat common application, the option of type parameter is &quot;wx_card&quot; or &quot;jsapi&quot;(refer WeChat Official document).","ref":"WeChat.Storage.Hub.html#c:save_ticket/4","title":"WeChat.Storage.Hub.save_ticket/4","type":"callback"},{"doc":"For common application.defmodule MyClient do use WeChat, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, appid: &quot;MyAppID&quot; endThe above equals as belowdefmodule MyClient do use WeChat, adapter_storage: { WeChat.Storage.Adapter.DefaultClient, &quot;http://localhost:4000&quot; }, appid: &quot;MyAppID&quot; endWhen uses the {:default, &quot;MyHubBaseURL&quot;}, there requires some HTTP API functions are provided by the hub web app server, let's take &quot;MyHubBaseURL&quot; as &quot;http://localhost:4000&quot; for example.Refresh access tokenRequest - method: POST http://localhost:4000/refresh/access_token - body: %{&quot;appid&quot; =&gt; &quot;MyAppID&quot;, &quot;access_token&quot; =&gt; &quot;CurrentExpiryAccessToken&quot;} - body format: json Response - success body: %{&quot;access_token&quot; =&gt; &quot;...&quot;, &quot;expires_in&quot; =&gt; integer(), &quot;timestamp&quot; =&gt; integer()} - error body: any content is acceptable will be return back into `WeChat.Error`Fetch access tokenRequest - method: GET http://localhost:4000/client/access_token - query string: appid=&quot;MyAppID&quot; Response - success body: %{&quot;access_token&quot; =&gt; &quot;...&quot;, &quot;expires_in&quot; =&gt; integer(), &quot;timestamp&quot; =&gt; integer()} - error body: any error content is acceptable will be return back into `WeChat.Error`Fetch jsapi-ticket/card-ticketRequest - method: GET http://localhost:4000/client/ticket - query string: appid=&quot;MyAppID&quot;&amp;type=jsapi or appid=&quot;MyAppID&quot;&amp;type=wx_card Response - success body: %{&quot;ticket&quot; =&gt; &quot;...&quot;, &quot;expires_in&quot; =&gt; integer(), timestamp =&gt; integer(), &quot;type&quot; =&gt; &quot;jsapi&quot; | &quot;wx_card&quot;} - error body: any error content is acceptable will be return back into `WeChat.Error`","ref":"WeChat.Storage.Adapter.DefaultClient.html","title":"WeChat.Storage.Adapter.DefaultClient","type":"module"},{"doc":"For component application.defmodule MyClient do use WeChat.Component, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, appid: &quot;MyComponentAppID&quot; endThe above equals as belowdefmodule MyClient do use WeChat.Component, adapter_storage: { WeChat.Storage.Adapter.DefaultComponentClient, &quot;http://localhost:4000&quot; }, appid: &quot;MyComponentAppID&quot; endWhen uses the {:default, &quot;MyHubBaseURL&quot;}, there requires some HTTP API functions are provided by the hub web app server, let's take &quot;MyHubBaseURL&quot; as &quot;http://localhost:4000&quot; for example.Refresh authorizer access_tokenRequest - method: POST http://localhost:4000/refresh/access_token - body: %{&quot;appid&quot; =&gt; &quot;Your3rdComponentAppID&quot;, &quot;authorizer_appid&quot; =&gt; &quot;YourAuthorizerAppID&quot;, &quot;access_token&quot; =&gt; &quot;CurrentExpiryAccessToken&quot;} - body format: json Response - success body: %{&quot;access_token&quot; =&gt; &quot;...&quot;, &quot;expires_in&quot; =&gt; integer(), &quot;timestamp&quot; =&gt; integer()} - error body: any content is acceptable will be return back into `WeChat.Error`Fetch access_tokenRequest - method: GET http://localhost:4000/client/access_token - query string: appid=&quot;MyAppID&quot; Response - success body: %{&quot;access_token&quot; =&gt; &quot;...&quot;, &quot;expires_in&quot; =&gt; integer(), &quot;timestamp&quot; =&gt; integer()} - error body: any error content is acceptable will be return back into `WeChat.Error`Fetch jsapi-ticket/card-ticketRequest - method: GET http://localhost:4000/client/ticket - query string: appid=&quot;MyAppID&quot;&amp;type=jsapi or appid=&quot;MyAppID&quot;&amp;type=wx_card Response - success body: %{&quot;ticket&quot; =&gt; &quot;...&quot;, &quot;expires_in&quot; =&gt; integer(), &quot;timestamp&quot; =&gt; integer(), &quot;type&quot; =&gt; &quot;jsapi&quot; | &quot;wx_card&quot;} - error body: any error content is acceptable will be return back into `WeChat.Error`","ref":"WeChat.Storage.Adapter.DefaultComponentClient.html","title":"WeChat.Storage.Adapter.DefaultComponentClient","type":"module"},{"doc":"A WeChat Card signature expression.","ref":"WeChat.CardSignature.html","title":"WeChat.CardSignature","type":"module"},{"doc":"","ref":"WeChat.CardSignature.html#t:t/0","title":"WeChat.CardSignature.t/0","type":"type"},{"doc":"A WeChat error expression.","ref":"WeChat.Error.html","title":"WeChat.Error","type":"exception"},{"doc":"","ref":"WeChat.Error.html#t:t/0","title":"WeChat.Error.t/0","type":"type"},{"doc":"A WeChat JSSDK signature expression.","ref":"WeChat.JSSDKSignature.html","title":"WeChat.JSSDKSignature","type":"module"},{"doc":"","ref":"WeChat.JSSDKSignature.html#t:t/0","title":"WeChat.JSSDKSignature.t/0","type":"type"},{"doc":"Use for upload media file related.","ref":"WeChat.UploadMedia.html","title":"WeChat.UploadMedia","type":"module"},{"doc":"","ref":"WeChat.UploadMedia.html#t:t/0","title":"WeChat.UploadMedia.t/0","type":"type"},{"doc":"Use for upload media file content related.","ref":"WeChat.UploadMediaContent.html","title":"WeChat.UploadMediaContent","type":"module"},{"doc":"","ref":"WeChat.UploadMediaContent.html#t:t/0","title":"WeChat.UploadMediaContent.t/0","type":"type"},{"doc":"ElixirWeChat Elixir API wrapper for WeChat.","ref":"readme.html","title":"ElixirWeChat","type":"extras"},{"doc":"At present, there are two ways to build application in WeChat Official Account open ecosystem:Integrates public APIs after turn on your WeChat Official Account into the developer mode (see details), here named it as common application in document of elixir_wechat, the same below;Authorizes your WeChat Official Account to the WeChat Official Account third-party platform application (see details), here named it as component application in document of elixir_wechat, the same below.This library wants to provide a flexible way to explicitly call all of WeChat's API functions, meanwhile helps to maintain the fetch-expiry-refresh loop cycle of access_token, you can choose your way to storage access_token, jssdk-ticket and card-ticket as well.","ref":"readme.html#introduction","title":"ElixirWeChat - Introduction","type":"extras"},{"doc":"Refer the official document's recommend there needs the centralization nodes to maintain the life cycle of access_token (fetch/storage/refresh).This library is designed for these four use scenarios:ApplicationScenarioStorage BehaviourcommonclientWeChat.Storage.ClientcommonhubWeChat.Storage.HubcomponentclientWeChat.Storage.ComponentClientcomponenthubWeChat.Storage.ComponentHubNotice:The above &quot;client&quot; means the business logic which rely on the access_token maintained by the centralization nodes;The above &quot;hub&quot; means the implements in the centralization nodes.","ref":"readme.html#background","title":"ElixirWeChat - Background","type":"extras"},{"doc":"Installdef deps do [ {:elixir_wechat, &quot;~&gt; 0.3&quot;} ] endHttp ClientCurrently, this library uses Tesla.Adapter.Finch to process http request/response, you can optionally define Finch's default pool setting like this:config :elixir_wechat, pool_size: 100, pool_count: 1pool_size, optional, number of connections to maintain in each pool, see Finch.request/6 for details, default to 100.pool_count, optional, number of pools to start, see Finch.request/6 for details, default to 1.UsageFirst of all, let's add the built-in plug into the router of your server:plug WeChat.Plug.Pipeline, adapter_storage: [ component: WeChat.Storage.ComponentLocal, common: WeChat.Storage.Local ]The adapter_storage option is required, according to your use case, you need to implement your common or component storage refer the corresponding behaviour, if your server need to cover both of them, just add them as the same time.After the above setup, there will add the following URLs into your server for internal interactive, both of them are used to read/write cacheable data from the centralization nodes.POST &quot;/refresh/access_token&quot; GET &quot;/client/access_token&quot; GET &quot;/client/component_access_token&quot; GET &quot;/client/ticket&quot;For example, assume that the above setup server is running as &quot;http://localhost:4000&quot;, now let's invoke a detailed WeChat's API as an example from the client side.POST &quot;https://api.weixin.qq.com/cgi-bin/material/batchget_material&quot; QueryString: access_token=&quot;ACCESS_TOKEN&quot; Body: {&quot;type&quot;: &quot;image&quot;, &quot;offset&quot;: 0, &quot;count&quot;: 10}As common client applicationdefmodule MyClient do use WeChat, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, appid: &quot;MyAppID&quot; end MyClient.request( :post, url: &quot;/cgi-bin/material/batchget_material&quot;, body: %{type: &quot;image&quot;, offset: 0, count: 10} )Or use WeChat.request/2 directlyWeChat.request( :post, appid: &quot;MyAppID&quot;, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, url: &quot;/cgi-bin/material/batchget_material&quot;, body: %{type: &quot;image&quot;, offset: 0, count: 10} )As component client applicationdefmodule MyComponentClient do use WeChat.Component, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, appid: &quot;MyAppID&quot;, authorizer_appid: &quot;MyAuthorizerAppID&quot; end MyComponentClient.request( :post, url: &quot;/cgi-bin/material/batchget_material&quot;, body: %{type: &quot;image&quot;, offset: 0, count: 10} )Or use WeChat.request/2 directlyWeChat.request( :post, appid: &quot;MyAppID&quot;, authorizer_appid: &quot;MyAuthorizerAppID&quot;, adapter_storage: {:default, &quot;http://localhost:4000&quot;}, url: &quot;/cgi-bin/material/batchget_material&quot;, body: %{type: &quot;image&quot;, offset: 0, count: 10} )Please notice the access_token parameter will be automatically appended by this library, if access_token is expired when calling, there will retry refresh access_token from self-host centralization nodes, and then self-host centralization nodes will maintain the life cycle of a fresh access_token.The default adapter storage {:default, &quot;http://localhost:4000&quot;} is implemented as a client to the hub server(s) via some predefined HTTP API functions, the WeChat.Storage.Adapter.DefaultClient is used for common application, and the WeChat.Storage.Adapter.DefaultComponentClient is used for component application.In general use, you need to define your adapter storage implemented the corresponding behaviour, the aim of this design to adapt as much as you want.","ref":"readme.html#how-to-use","title":"ElixirWeChat - How to use","type":"extras"},{"doc":"$ mix docs","ref":"readme.html#document","title":"ElixirWeChat - Document","type":"extras"},{"doc":"First you need to add the following environment variables in the config/test.exs, and then run mix test in the root of this repo.System.put_env(&quot;TEST_COMMON_APPID&quot;, &quot;...&quot;) System.put_env(&quot;TEST_COMPONENT_APPID&quot;, &quot;...&quot;) System.put_env(&quot;TEST_HUB_URL&quot;, &quot;...&quot;) System.put_env(&quot;TEST_OPENID&quot;, &quot;...&quot;)","ref":"readme.html#test","title":"ElixirWeChat - Test","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"ElixirWeChat - License","type":"extras"}]